Global( "EVRe", {} )
--------
function Reg (ER)
for k, v in pairs(ER) do
	if string.find(k, "EVENT_") or string.find(k, "SCRIPT_") then
		common.RegisterEventHandler(v, k)
	else
		common.RegisterReactionHandler(v, k)
	end
end
end

--EVENTS
EVRe["SCRIPT_TOGGLE_UI"] = function(params)
mainForm:Show( params.visible )
end

EVRe["U_EVENT_ADDON_MEM_USAGE_REQUEST"] = function(params)
userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", {sender = common.GetAddonName(), memUsage = gcinfo()})
end

EVRe["EVENT_UNITS_CHANGED"] = function(params)
FixId(params.spawned)
end

EVRe["EVENT_HEALING_RECEIVED"] = function(params)
if Battle.cnf.freeze then return end
if Battle.bin or Battle.dmge then
	AddData (params)
end
end

EVRe["EVENT_UNIT_DAMAGE_RECEIVED"] = function(params)
--common.LogInfo(common.GetAddonName(),"EVENT_UNIT_DAMAGE_RECEIVED")
if Battle.cnf.freeze then return end
if Battle.bin or Battle.dmge then
	AddData (params)
else
	Battle.lastp = params
end
end

EVRe["EVENT_AVATAR_COMBAT_STATUS_CHANGED"] = function(params)
--common.LogInfo(common.GetAddonName(),"EVENT_AVATAR_COMBAT_STATUS_CHANGED")
mainForm:GetChildUnchecked("BtnFreeze", false):SetVariant(params.inCombat and 3 or 2)
if Battle.cnf.freeze then
	Battle.bin = false
	Battle.dmge = false
	return
end
if not Battle.bin and params.inCombat then
	StartFigth()
	if Battle.lastp then
		AddData (Battle.lastp)
		Battle.lastp = nil
	end
elseif params.inCombat then
	common.LogInfo(common.GetAddonName(),"Repeat_inCombat!!")
	common.LogInfo(common.GetAddonName(),"CurFight.ftime - ", Format02d(CurFight.ftime))
end
Battle.bin = params.inCombat
end

EVRe["EVENT_SECOND_TIMER"] = function(params)
if Battle.cnf.freeze then return end
if Battle.dmge then
	CurFight.ftime = CurFight.ftime + params.elapsedMs
	if Battle.ref > 1 then
		Battle.ref = Battle.ref - 1
	else
		Battle.ref = VRefresh
		--common.LogInfo(common.GetAddonName(),"EVENT_SECOND_TIMER - CurFight.ftime - ", common.FormatInt(CurFight.ftime,"%n"))
		RefrVisData ()
	end
	if not Battle.bin then
		if CurFight.fName then
			--InsertFight()
			IF()
			RefrVisData()
			--SaveFightincfg()
		end
		Battle.dmge = false
		Battle.lastp = nil
	end
end
end

EVRe["EVENT_AVATAR_CREATED"] = function(params)
DataInit()
end

--REACTIONS
EVRe["btn_UpDown"] = function(reaction)
if reaction.widget:GetVariant() == 0 then
	reaction.widget:SetVariant(1)
	mainForm:GetChildUnchecked("PanelGroup", false):Show(true)
	RefrVisData()
else
	reaction.widget:SetVariant(0)
	mainForm:GetChildUnchecked("PanelGroup", false):Show(false)
end
Battle.cnf.gropened = mainForm:GetChildUnchecked("PanelGroup", false):IsVisible()
Config(true)
end

EVRe["btn_Detail"] = function(reaction)
if DnD.IsPicked then return end
local wdt = reaction.widget:GetParent():GetParent()
--common.LogInfo(common.GetAddonName(),"btn_Detail")
if wdt:GetName() == "PanelDetail" then wdt:Show(false)
elseif Fights[1] then
	wdt = mainForm:GetChildUnchecked("PanelDetail", false):GetChildUnchecked("TextAddon", false)
	wdt:SetVal("Hist", Format02d(table.getn(Fights)))
	wdt:SetVal("Max", Format02d(MaxHistory))
	wdt:SetVal("Name", userMods.ToWString(common.GetAddonName()))
	wdt:SetVal("rdate", userMods.ToWString(rdate))
	wdt:SetVal("rev", Format02d(revision))
	wdt:SetVal("memo", Format45d(gcinfo()*1e3))
	Battle.checkout = 0
	if Battle.cnf.fighis then PlaceFights(1)
	else PlaceFighters ()
	end
	mainForm:GetChildUnchecked("PanelDetail", false):Show(true)
	mainForm:GetChildUnchecked("PanelSelect", false):Show(false)
	mainForm:GetChildUnchecked("CFMenu", false):Show(false)
end
end

EVRe["btn_Nil"] = function(reaction)
--if DnD.IsPicked then return end
if reaction.widget:GetParent():GetName() == "PanelHeader" then
	local wdt, hm = mainForm:GetChildUnchecked("PanelSelect", false), GetHisMode()
	if not wdt:IsVisible() then
		for u,t in wdt:GetNamedChildren() do
			t:SetVariant(t:GetName() == hm and 1 or 0)
		end
	end
	wdt:Show(not wdt:IsVisible())
else
	local wdt, hm = mainForm:GetChildUnchecked("CFMenu", false), GetVisMode()
	if not wdt:IsVisible() then
		for u,t in wdt:GetNamedChildren() do
			t:SetVariant(t:GetName() == hm and 1 or 0)
		end
	end
	wdt:Show(not wdt:IsVisible())
end
end

EVRe["btn_DNil"] = function(reaction)
if string.find(reaction.sender, "BtnDU_") then
	PlaceFighters(tonumber(string.sub (reaction.sender,7)))
elseif string.find(reaction.sender, "BtnD_") then
	if not Battle.cnf.fighis then
		PlaceFights (tonumber(string.sub (reaction.sender,6)))
	end
	PlaceSpells(tonumber(string.sub (reaction.sender,6)))
elseif string.find(reaction.sender, "BtnFD_") then
	PlaceTimes(tonumber(string.sub (reaction.sender,7)))
end
end

EVRe["btn_Freeze"] = function(reaction)
GoSleep (not Battle.cnf.freeze)
end

EVRe["PS_op"] = function(reaction)
if string.find(reaction.sender, "PnlS_") then
	PlaceSDetail(tonumber(string.sub (reaction.sender,6)))
end
end

EVRe["btn_Selct"] = function(reaction)
--common.LogInfo(common.GetAddonName(),"btn_Selct", reaction.sender)
mainForm:GetChildUnchecked("PanelSelect", false):Show(false)
mainForm:GetChildUnchecked("CFMenu", false):Show(false)
end

EVRe["btn_unSelct"] = function(reaction)
if reaction.widget:GetParent():GetName() == "CFMenu" then
	if reaction.sender == "Reset" then
		mainForm:GetChildUnchecked("PanelDetail", false):Show(false)
		Resetdata ()
	elseif reaction.sender ~= "Lne" then
		SetVisMode (reaction.sender)
		Config(true)
	end
	mainForm:GetChildUnchecked("CFMenu", false):Show(false)
else
	if string.find(reaction.sender, "Reset") then
		mainForm:GetChildUnchecked("PanelDetail", false):Show(false)
		Resetdata ()
	elseif reaction.sender ~= "Lne" then
		SetHisMode (reaction.sender)
		if Battle.cnf.fighis then PlaceFights(1)
		else PlaceFighters ()
		end
		Config(true)
		--common.LogInfo(common.GetAddonName(), Format45d(GetHisMode()))
	end
	mainForm:GetChildUnchecked("PanelSelect", false):Show(false)
end
RefrVisData()
end

EVRe["panel_over"] = function(reaction)
common.LogInfo(common.GetAddonName(),"panel_over ", reaction.sender)
end