--DnD functions
Global("DnDEV", {})
Global("DnD", {})

function DnDInit()
local pos
for k, v in pairs(DnDEV) do
	common.RegisterEventHandler(v, k)
end
DnD.ID = DND_WIDGET_MOVE * DND_CONTAINER_STEP + 559
--DnD.wtReacting = PMain[2]:GetParent():GetChildUnchecked("BtnNil", false)
DnD.wtMovable = PUnit[1]:GetParent()
DnD.IsPicked = false
DnD.SCSection = common.GetAddonName().."_"..DnD.ID.."_"..revision
DnD.Place = DnD.wtMovable:GetPlacementPlain()
if CheckVer() < 1102 then
	pos = common.GetGlobalConfigSection(DnD.SCSection)
else
	pos = userMods.GetGlobalConfigSection(DnD.SCSection)
end
DnD.Place.posX = pos and pos.posX or 50
DnD.Place.posY = pos and pos.posY or 300

DnD.Screen = widgetsSystem:GetPosConverterParams()
DnD.Place.posX = (DnD.Screen.fullVirtualSizeX > (DnD.Place.posX + 0.5 * DnD.Place.sizeX)) and DnD.Place.posX or DnD.Screen.fullVirtualSizeX - 0.5 * DnD.Place.sizeX
DnD.Place.posY = (DnD.Screen.fullVirtualSizeY > (DnD.Place.posY + 50)) and DnD.Place.posY or DnD.Screen.fullVirtualSizeY - 50
DnD.Place.posX = ((DnD.Place.posX - DnD.Place.sizeX) > 1.5 * -DnD.Place.sizeX) and DnD.Place.posX or 0
DnD.Place.posY = (DnD.Place.posY > 0) and DnD.Place.posY or 0
DnDReg ()
end

function DnDReg ()
DnD.wtMovable:SetPlacementPlain(DnD.Place)
mission.DNDRegister(PMain[2]:GetParent():GetChildUnchecked("BtnNil", false), DnD.ID, true )
mission.DNDRegister(mainForm:GetChildUnchecked("PanelDetail", false):GetChildUnchecked("PanelHeader", false):GetChildUnchecked("BtnNil", false), DnD.ID+1, true )
end

---
DnDEV["EVENT_DND_PICK_ATTEMPT"] = function(params)
--common.LogInfo(common.GetAddonName(),"EVENT_DND_PICK_ATTEMPT")
if (params.srcId == DnD.ID) or (params.srcId == DnD.ID+1) then
--common.LogInfo(common.GetAddonName(),"params.srcId == DnD.ID")
	if CheckVer() > 2000 then mission.DNDConfirmPickAttempt() end
	DnD.Screen = widgetsSystem:GetPosConverterParams()
	DnD.Place = DnD.wtMovable:GetPlacementPlain()
	DnD.DeltaX = params.posX * DnD.Screen.fullVirtualSizeX / DnD.Screen.realSizeX - DnD.Place.posX
	DnD.DeltaY = params.posY * DnD.Screen.fullVirtualSizeY / DnD.Screen.realSizeY - DnD.Place.posY
	--common.SetCursor( "drag" )
	DnD.IsPicked = true
end
end

DnDEV["EVENT_DND_DROP_ATTEMPT"] = function(params)
--common.LogInfo(common.GetAddonName(),"EVENT_DND_DROP_ATTEMPT")
if DnD.IsPicked then
	local XY = {posX = DnD.wtMovable:GetPlacementPlain().posX,
				posY = DnD.wtMovable:GetPlacementPlain().posY}
	mission.DNDConfirmDropAttempt()
	--common.SetCursor( "default" )
	DnD.IsPicked = false
	if CheckVer() < 1102 then
		common.SetGlobalConfigSection(DnD.SCSection, XY)
	else
		userMods.SetGlobalConfigSection(DnD.SCSection, XY)
	end
end
end

DnDEV["EVENT_DND_DRAG_TO"] = function(params)
--common.LogInfo(common.GetAddonName(),"EVENT_DND_DRAG_TO")
if DnD.IsPicked then
	--common.LogInfo(common.GetAddonName(),"IsPicked")
	DnD.Place.posX = params.posX * DnD.Screen.fullVirtualSizeX / DnD.Screen.realSizeX - DnD.DeltaX
	DnD.Place.posY = params.posY * DnD.Screen.fullVirtualSizeY / DnD.Screen.realSizeY - DnD.DeltaY
	DnD.wtMovable:SetPlacementPlain( DnD.Place )
	--common.SetCursor( "drag" )
end
end